/*  T630 BACKUP UTILITY v1.0 by AcidBorg
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <libxml/parser.h>

int main(int argc,char** argv){
	
	int status;
	pid_t pid;
	char* command[8];
	char list[100];
	int cont;
	xmlDocPtr doc;
	xmlNodePtr root;
	xmlNodePtr node;	
	
	/*Right usage control*/
	if (argc!=3) {
		printf("Use: t630-backup [Phone's MAC] Pictures|Themes|Sounds\n");
		exit(1);
		}
	/*Check if argv[2] is a mac address*/

	if ((strcmp(argv[2],"Pictures")) &&  (strcmp(argv[2],"Themes")) && (strcmp(argv[2],"Sounds"))) {
		printf("Possible directories are: Pictures , Themes or Sounds\n");
		exit(1);
		}

	/*List phone files*/
	strcpy(list,"obexftp -b ");
	strcat(list,argv[1]);
	strcat(list," -c ");
	strcat(list,argv[2]);
	strcat(list," -l > t630-backup.xml");
	system(list);

	/*Create the XML tree */
	doc = xmlParseFile("t630-backup.xml");
	if(!doc) {
		perror("Error creating XML tree");
		exit(1);
		}
   	root = xmlDocGetRootElement(doc);
   	node = root->xmlChildrenNode;
	node=node->next->next;
	
	/*Downloads the entire folder*/
  	while (node) {
		pid=fork();
		switch(pid){
			case -1:
				perror("Error downloading files");
				exit(1);
				break;
			
			case 0:
				for(cont=0;cont<8;cont++) command[cont]=(char *) malloc(50*sizeof(char));
				strcpy(command[0],"obexftp");
				strcpy(command[1],"-b");
				strcpy(command[2],argv[1]);
				strcpy(command[3],"-c");
				strcpy(command[4],argv[2]);
				strcpy(command[5],"-g");
				strcpy(command[6],(char *)node->properties->children->content);
				command[7]=NULL;
				execvp(command[0],command);
				for(cont=0;cont<8;cont++) free(command[cont]);
				break;
			
			default:
				while (pid!=wait(&status));
				break;
			}
		/*Selects next file*/
		node = node->next->next;
		}
if (remove("t630-backup.xml")){
	perror("Error deleting XML file");
	exit(1);
	}
return 0;
}
